/*******************************************************************************


     HORIMETRO.C


     AUTOR: CLAUDIO LARIOS

     DATA: 07/08/2015

     COM 5 DIGITOS DE 7 SEGUIMENTOS (0,0 - 9999,9 HORAS)

     APAGA DIGITOS COM ZERO A ESQUERDA
     COM DEZENAS DE MINUTOS CENTESIMAL (6 MIN/UN) NA CASA APS PONTO.
     UTILIZA XTAL DE 4 NHZ

     OBJETIVO: MARCAR HORAS TRABALHADAS EM EQUIPAMENTOS COMO EMPILHADEIRAS,
     MAQUINAS INDUSTRIAIS, ETC, PARA FINS DE MANUTENO PERIDICA.

     OBS. MONTAGEM DE NATUREZA DIDTICA.

     ESTE ARQUIVO  PARTE INTEGRANTE DO BLOG LARIOS.TECNOLOGIA.WS


*******************************************************************************/
//            DEFINIO DO USURIO
/******************************************************************************/
//   ESCOLHA O TIPO DE DISPLAY :  CATODO OU ANODO COMUM

     #DEFINE  ANODO_COMUM

// Descomente para catodo comum

//==============================================================================
//  ESCOLHA SE VAI APARECER OU NO OS ZEROS A ESQUERDA

  #DEFINE  N_MOSTRA_ZERO_ESQUERDOS

// DESCOMENTE PARA MOSTRAR OS ZEROS A ESQUERDA
//==============================================================================

#include <16F628A.h>
#use delay(clock=4000000)
#fuses NOWDT,XT, PUT, NOPROTECT, BROWNOUT, MCLR, NOLVP, NOCPD

#byte portb = 0x06
#byte porta = 0x05
#byte trisa = 0x85
#byte trisb = 0x86

//#bit  led   = 0x05.4 //led opcional (pino 3 ao resistor 1k +led ao vcc)

#rom 0x2100 ={0,0,0,0,0} //situao inicial da eeprom ps programao do pic

//constantes
int8 const n_dig = 5;//nmero de digitos a ser apresentado

//                         PGFEDCBA   SEGUIMENTOS
//                   PORTB 76543210
int8 const NUM[] = {     0B00111111,//0
                         0B00000110,//1
                         0B01011011,//2
                         0B01001111,//3
                         0B01100110,//4
                         0B01101101,//5
                         0B01111101,//6
                         0B00000111,//7
                         0B01111111,//8
                         0B01101111 //9
                                          };
                                          
//variavis globais                                          

 unsigned int8 seg,min,minc,hor1,hor2,hor3,hor4,vez,cnt;
 int1 f_aux,f_z;


/*==============================================================================
       ROTINA QUE BUSCA VALOR DE MINUTOS GRAVADO EM POSIES DIFERENTES DA
       EEPROM - (AUMENTAR VIDA UTIL DA EEPROM)
==============================================================================*/

int8 pega_min(){ // valor de minutos poder estar entre posio 4 e 127
   int8 a;
   for(a=4;a<127;a++){
    if(read_eeprom(a)!=0xff) return (a);//retorna posio onde est 'min'

   }
 }
/*==============================================================================
       ROTINA QUE GRAVA VALOR DE MINUTOS EM POSIES DIFERENTES DA
       EEPROM - (AUMENTAR VIDA UTIL DA EEPROM)
==============================================================================*/

void grava_min(int8 b){// valor de minutos poder estar entre posio 4 e 127
  if(b<127) {
     write_eeprom((b+1),min);//grava a prxima posio
     write_eeprom (b,0xff);}//apaga a anterior
  else{
      write_eeprom(4,min);//grava no inicio do espao reservado para minutos
    }

}
/*==============================================================================
       ROTINA PARA CONVERTER MINUTOS EM DCIMOS DE HORA (MOSTRA DE 0 - 9),
       SENDO CADA UNIDADE IGUAL A 6 MINUTOS.
==============================================================================*/

void min_cent(){
  int8 c; 
   c=min;
   minc=0;
   while(c>5) {
   c-=6;
   if(++minc>9) minc=0;
   }
}
/*==============================================================================
       ROTINA DE INTERRUPO DO TIMER 0 (OBTEM TEMPO DE 1 SEGUNDO)
==============================================================================*/

 #INT_TIMER0
 VOID ISR_TIMER0(){
 
    set_timer0(get_timer0() + 131);//carga do timer para obter 8ms
    if(++cnt>=125){// 8ms * 125= 1seg
       cnt=0;
       if(++seg>59) {
          seg=0;
          f_aux=1; 
          if(++min>59) {
            min=0; if(++hor1>9){
              hor1=0; if(++hor2>9){
                 hor2=0; if(++hor3>9) {
                    hor3=0; if(++hor4>9) hor4=0;
                         }
                     }
                 }
             }
         }
     }
 }
/*==============================================================================
       ROTINA MAIN - CONFIGURAO DE PORTAS E REGISTRADORES
==============================================================================*/


void main() {


   setup_counters(RTCC_INTERNAL,RTCC_DIV_64);//TIMER0  COM PRESCALLER /64
   setup_timer_1(T1_DISABLED);//desliga timer1
   setup_timer_2(T2_DISABLED,0,1);//desliga timer2
   setup_comparator(NC_NC_NC_NC);//desliga comparadores
   setup_vref(FALSE);//desliga vref
   set_timer0(131);//PRE-CARGA INICIAL
   cnt=0;//ZERA CONTADOR
   enable_interrupts(int_timer0);//liga interrupo do timer 0
   enable_interrupts(global);//liga chave geral das interrupes
   trisa=0b11100000;//ajusta sentido das ports
   trisb=0;//tudo saida
   porta=0;//condio inicial



   seg=30;//media inicial
   hor1= read_eeprom(0);//retorna valores salvos
   hor2= read_eeprom(1);
   hor3= read_eeprom(2);
   hor4= read_eeprom(3);
   min=  read_eeprom(pega_min());

//==============================================================================
//               LOOP PRINCIPAL DE REPETIO
//==============================================================================

  for(;;){
    min_cent(); //ajusta p/ mostrar dcimos de horas (6min por unidade)
//  rotina de multiplexao dos displays de 7 seguimentos
    if(++vez>=n_dig) vez=0;
    porta=porta&0xE0;//apaga display
    #IFDEF N_MOSTRA_ZERO_ESQUERDOS
    f_z=1;//seta flag de zero a esquerda
    #ELSE
    f_z=0;
    #ENDIF
    switch (vez){

     case 0: {
       portb=num[hor4];
       #ifdef ANODO_COMUM
       portb=~portb;
       #endif
       if(!hor4&&f_z)break;
       porta= porta|8;
       f_z=0;
       break;}
     case 1: {
       portb=num[hor3];
       #ifdef ANODO_COMUM
       portb=~portb;
       #endif
       if(!hor3&&f_z)break;
       porta= porta|4;
       f_z=0;
       break;}
     case 2: {
       portb=num[hor2];
       #ifdef ANODO_COMUM
       portb=~portb;
       #endif
       if(!hor2&&f_z)break;
       porta= porta|2;
       f_z=0;
       break;}
     case 3: {
       portb=num[hor1];
       portb|=0x80; //acende ponto
       #ifdef ANODO_COMUM
       portb=~portb;
       #endif
       porta= porta|1;
       break;}

     case 4:{
       portb=num[minc];
       #ifdef ANODO_COMUM
       portb=~portb;
       #endif
       porta= porta|16;
       break;}
      }


 //rotina de salvamento na eeprom de mudanas nos contadores de tempo
    if(f_aux){
      f_aux=0;
      grava_min(pega_min()); //salva mudana em minutos
      if(hor1!=read_eeprom(0)){write_eeprom(0,hor1);} //salva mudana em unidade de horas
      if(hor2!=read_eeprom(1)){write_eeprom(1,hor2);}//salva mudana em dezenas de horas
      if(hor3!=read_eeprom(2)){write_eeprom(2,hor3);}//salva mudana em centenas de horas
      if(hor4!=read_eeprom(3)){write_eeprom(3,hor4);}//salva mudana em milhares de horas
    }
    else{
      delay_ms(2);//delay de tempo para multiplexao correta
     
      
    }

  }
}
